aboutsummaryrefslogtreecommitdiff
diff options
context:
space:
mode:
authorTarmigan Casebolt <tarmigan+git@gmail.com>2010-01-02 13:43:59 -0800
committerJunio C Hamano <gitster@pobox.com>2010-01-06 01:18:37 -0800
commitfd0a8c2e6428acb883bf4707de54b3e026c57455 (patch)
tree17bf67c72b4cd41fccf0c3355021030e52e1e9c9
parent04481adffe7d4d969d7067d7a6d6e5e46e44f1c8 (diff)
downloadgit-fd0a8c2e6428acb883bf4707de54b3e026c57455.tar.gz
git-fd0a8c2e6428acb883bf4707de54b3e026c57455.tar.xz
Smart-http tests: Test http-backend without curl or a webserver
This reuses many of the tests from the old t5560 but runs those tests without curl or a webserver. This will hopefully increase the testing coverage for http-backend because it does not require users to set GIT_TEST_HTTPD. Signed-off-by: Tarmigan Casebolt <tarmigan+git@gmail.com> Signed-off-by: Junio C Hamano <gitster@pobox.com>
-rwxr-xr-xt/t5560-http-backend-noserver.sh28
-rwxr-xr-xt/t556x_common3
2 files changed, 25 insertions, 6 deletions
diff --git a/t/t5560-http-backend-noserver.sh b/t/t5560-http-backend-noserver.sh
index a9ba2d9aa..5f8c88e26 100755
--- a/t/t5560-http-backend-noserver.sh
+++ b/t/t5560-http-backend-noserver.sh
@@ -6,18 +6,34 @@ test_description='test git-http-backend-noserver'
HTTPD_DOCUMENT_ROOT_PATH="$TRASH_DIRECTORY"
run_backend() {
- REQUEST_METHOD=GET \
+ echo "$2" |
+ QUERY_STRING="${1#*\?}" \
GIT_PROJECT_ROOT="$HTTPD_DOCUMENT_ROOT_PATH" \
- PATH_INFO="$1" \
+ PATH_INFO="${1%%\?*}" \
git http-backend >act.out 2>act.err
}
GET() {
- return 0
+ REQUEST_METHOD="GET" \
+ run_backend "/repo.git/$1" &&
+ if ! grep "Status" act.out >act
+ then
+ printf "Status: 200 OK\r\n" >act
+ fi
+ printf "Status: $2\r\n" >exp &&
+ test_cmp exp act
}
POST() {
- return 0
+ REQUEST_METHOD="POST" \
+ CONTENT_TYPE="application/x-$1-request" \
+ run_backend "/repo.git/$1" "$2" &&
+ if ! grep "Status" act.out >act
+ then
+ printf "Status: 200 OK\r\n" >act
+ fi
+ printf "Status: $3\r\n" >exp &&
+ test_cmp exp act
}
log_div() {
@@ -28,9 +44,9 @@ log_div() {
expect_aliased() {
if test $1 = 0; then
- run_backend "$2"
+ REQUEST_METHOD=GET run_backend "$2"
else
- run_backend "$2" &&
+ REQUEST_METHOD=GET run_backend "$2" &&
echo "fatal: '$2': aliased" >exp.err &&
test_cmp exp.err act.err
fi
diff --git a/t/t556x_common b/t/t556x_common
index 1b4921c87..be024e551 100755
--- a/t/t556x_common
+++ b/t/t556x_common
@@ -50,6 +50,7 @@ get_static_files() {
}
SMART=smart
+export GIT_HTTP_EXPORT_ALL=1
test_expect_success 'direct refs/heads/master not found' '
log_div "refs/heads/master"
GET refs/heads/master "404 Not Found"
@@ -59,6 +60,7 @@ test_expect_success 'static file is ok' '
get_static_files "200 OK"
'
SMART=smart_noexport
+unset GIT_HTTP_EXPORT_ALL
test_expect_success 'no export by default' '
log_div "no git-daemon-export-ok"
get_static_files "404 Not Found"
@@ -71,6 +73,7 @@ test_expect_success 'export if git-daemon-export-ok' '
get_static_files "200 OK"
'
SMART=smart
+export GIT_HTTP_EXPORT_ALL=1
test_expect_success 'static file if http.getanyfile true is ok' '
log_div "getanyfile true"
config http.getanyfile true &&